import javax.sound.midi.*;

/**
 * Plays a note through Midi
 * 
 * @author Michael Berry (mjrb4)
 * @version 08/01/09
 */
public class MidiPlayer  
{
    private MidiChannel[] channel;
    
    public MidiPlayer()
    {
        channel = getChannel();
    }
    

    public void play(final int note,final int length,final int instrument, final int volume)
    {
        new Thread() {
            public void run() {
                channel[instrument].noteOn(note, volume);
                try {
                    Thread.sleep(0);
                }
                catch(InterruptedException ex) {}
                finally {
                    channel[instrument].noteOff(note,50);
                }
            }
        }.run();
    }
    
    private MidiChannel[] getChannel()
    {
        try {
            Synthesizer synthesizer = MidiSystem.getSynthesizer();
            synthesizer.open();
            return synthesizer.getChannels();
        }
        catch(Exception ex) {
            ex.printStackTrace();
            return null;
        }
    }
}
